\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{cours_bts}[2011/08/22 Classe pour les cours]

\RequirePackage{etex}
\LoadClass[a4paper]{book}
\RequirePackage{type1ec}
%\RequirePackage{fourier}
%\RequirePackage{lmodern}
\RequirePackage[T1]{fontenc}
\RequirePackage[latin1]{inputenc}
\RequirePackage[nosolutionfiles]{answers}
\RequirePackage{frmin}
\RequirePackage{verbatim}
%\RequirePackage{hyperref}
%\RequirePackage{epsfig}
\RequirePackage[final]{graphicx}
\RequirePackage{multicol}
\RequirePackage{listings}
\RequirePackage{geometry}
\RequirePackage{maccours}
\RequirePackage{enumerate}
\RequirePackage{floatflt}
\RequirePackage{xr}
\RequirePackage{algo}
\RequirePackage{xy}
\RequirePackage[Glenn]{fncychap}
%\RequirePackage{fancyhdr}
\RequirePackage{makeidx}
\RequirePackage[french]{minitoc}
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{book}}

%%% Dfinition des marges
\geometry{a4paper,width=17cm,height=25.7cm,left=2cm,top=2cm,
  headheight=0cm,headsep=0cm, footskip=3em}
\setlength{\parindent}{0cm}
\setlength{\parskip}{1ex}
\pagestyle{plain}
\author{Nicolas FRANCOIS\\nicolas.francois@free.fr}
%\date{}

%%% Adaptation des commandes d'insertion d'index, de liste des figures
%%% et de la table des matires au format fancychap.
\renewenvironment{theindex}{%\addcontentsline{toc}{chapter}{}%
  \pagestyle{plain}\let\item\@idxitem\setlength{\parindent}{0pt}
  \setlength{\columnseprule}{0.4pt}
  \begin{multicols}{2}%[{\Large\bfseries Entres de l'index}]
    \par\bigskip}%
  {\end{multicols}}
\renewcommand*\l@chapter[2]{%
  \ifnum \c@tocdepth >\m@ne
    \addpenalty{-\@highpenalty}%
    \vskip 1.0em \@plus\p@
    \setlength\@tempdima{2.4em}%
    \begingroup
      \parindent \z@ \rightskip \@pnumwidth
      \parfillskip -\@pnumwidth
      \leavevmode \bfseries
      \advance\leftskip\@tempdima
      \hskip -\leftskip
      #1\nobreak\hfil \nobreak\hb@xt@\@pnumwidth{\hss #2}\par
      \penalty\@highpenalty
    \endgroup
  \fi}
\renewcommand*\l@section{\@dottedtocline{1}{1.5em}{3.2em}}
\renewcommand*\l@subsection{\@dottedtocline{2}{3.8em}{4.1em}}

\renewcommand*\l@figure{\@dottedtocline{1}{1.5em}{3.2em}}
\renewcommand\listoffigures{%
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \else
      \@restonecolfalse
    \fi
    \@starttoc{lof}%
    \if@restonecol\twocolumn\fi
    }

\renewcommand\tableofcontents{%
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \else
      \@restonecolfalse
    \fi
    \@starttoc{toc}%
    \if@restonecol\twocolumn\fi
    }

%%% Affichage du titre
%% \def\@maketitle{%
%%   \newpage
%%   \null
%%   \vskip 1.5em%
%%   \begin{center}%
%%   \let \footnote \thanks
%%     {\LARGE \@title \par}%
%%   \end{center}%
%%   \par
%%   \vskip 2em}

%%% Redfinition des commandes d'affichage des numros de section
\setcounter{secnumdepth}{10}
\renewcommand{\thechapter}{\Roman{chapter}}
\renewcommand{\thesection}{\Roman{section}}
\renewcommand{\thesubsection}{\Alph{subsection}}
\renewcommand{\thesubsubsection}{\arabic{subsubsection}}
\renewcommand{\theparagraph}{\roman{paragraph}}

%%% Redfinition des commandes d'affichage des numros de liste
%%% enumerees
\renewcommand{\theenumi}{\alph{enumi}}
\renewcommand{\labelenumi}{\theenumi)}
\renewcommand{\theenumii}{\arabic{enumii}}
\renewcommand{\labelenumii}{\theenumi\theenumii)}

%%% Changement de la fonte des numros de chapitre
%%% marche pas ?????
\def\ChNumVar{\bfseries\Huge\rm}

%%% Commande d'insertion de feuilles d'exercices
\newcounter{exos}
\newcommand{\exos}[1]{\clearpage%\phantomsection{}
  \addtocounter{exos}{1}\addcontentsline{toc}{section}{Feuille
    d'exercices n\theexos{} -- #1}
  \begin{center}
    \begin{fmpage}{0.9\linewidth}
      \begin{center}
        \Large Feuille d'exercices n\theexos{} -- #1
      \end{center}
    \end{fmpage}
  \end{center}\bigskip}

%%% Compteurs des diffrents thmes du programme
% Arithmtique
\newcounter{arith}
\newcommand{\Arith}{\addtocounter{arith}{1}{\begin{center}ARITHMTIQUE
      \thearith\end{center}}}
%Suites
\newcounter{suites}
\newcommand{\Suites}{\addtocounter{suites}{1}{\begin{center}SUITES
      NUMRIQUES \thesuites\end{center}}}
% Calcul matriciel
\newcounter{matr}
\newcommand{\Matr}{\addtocounter{matr}{1}{\begin{center}MATRICES
      \thematr\end{center}}}
% Logique
\newcounter{logic}
\newcommand{\Logic}{\addtocounter{logic}{1}{\begin{center}LOGIQUE
      \thelogic\end{center}}}
% Ensembles
\newcounter{setth}
\newcommand{\Setth}{\addtocounter{setth}{1}{\begin{center}THORIE DES
      ENSEMBLES \thesetth\end{center}}}
% Graphes
\newcounter{graph}
\newcommand{\Graph}{\addtocounter{graph}{1}{\begin{center}GRAPHES
      \thegraph\end{center}}}

%%% Titre large
\newcommand{\titrelarge}[1]{\textbf{\large #1}}

%%% Environnement minipage encadre
\newsavebox{\fmbox}
\newenvironment{fmpage}[1]
     {\begin{lrbox}{\fmbox}\begin{minipage}{#1}}
     {\end{minipage}\end{lrbox}\fbox{\usebox{\fmbox}}}
% \newenvironment{fmpage}[1]
%       {\begin{lrbox}{\fmbox}\begin{minipage}[t]{#1}}
%       {\end{minipage}\end{lrbox}\fbox{\usebox{\fmbox}}}
%%% Environnement pour gros nonc non encadr
\newcommand{\doubleligne}{\vspace{0.25cm}\hrule\vspace{0.05cm}\hrule\vspace{0.25cm}}
\newenvironment{grosenonce}{\doubleligne}{\doubleligne}

%%% Environnement partie centr
\newcommand{\Partie}[1]%
     {\begin{center}{\textsc{Partie} {#1}}\end{center}}
   
%%% Initialisation de ntheorem
\newtheoremstyle{mybreak}%
  {\item\hbox to \textwidth{\theorem@headerfont ##1\
      ##2\theorem@separator\hfill}\nopagebreak}%
  {\item\hbox to \textwidth{\theorem@headerfont ##1\ ##2\
      (##3)\theorem@separator\hfill}\nopagebreak}
% \newtheoremstyle{mybreak}%
%   {\item[\rlap{\vbox{\hbox{\hskip\labelsep \theorem@headerfont
%           ##1\ ##2\theorem@separator}\nopagebreak\hbox{\strut}}}]}%
%   {\item[\rlap{\vbox{\hbox{\hskip\labelsep \theorem@headerfont
%           ##1\ ##2\ (##3)\theorem@separator}\nopagebreak\hbox{\strut}}}]}
\theoremstyle{mybreak}
\theoremheaderfont{\large\bfseries}
\theorembodyfont{\normalfont}
\theoremindent0.5cm
\theoremseparator{\vspace{1ex}}
\theorempreskipamount0.5cm
\theorempostskipamount0.5cm
\newtheorem{Ex}{Exercice}[section]
% \theoremstyle{break}
% \theoremheaderfont{\large\bfseries}
% \theorembodyfont{\normalfont}
% \theoremindent0.5cm
% \theorempreskipamount0.5cm
% \theorempostskipamount0.5cm
% \newtheorem{Ex}{Exercice}[section]
%\newtheorem{Cours}{Question de cours}

%%% Les lignes de sparation
\newcommand{\ligne}{%
  \vspace{0.5cm}%
  \hrule%
  \vspace{0.5cm}%
  }
\newcommand{\Ligne}{%
  \vspace*{1cm}%
  \hrule%
  \vspace{0.5cm}%
  }
\newcommand{\lignepage}{% Quand il faut changer de page
  \vspace*{1cm}%
  \hrule%
  \newpage%
  }

%%% Options gnrales
\everymath={\displaystyle}  % toutes les formules en displaystyle

\parentActives